Index: arch/ppc/boot/prep/misc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/ppc/boot/prep/misc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/ppc/boot/prep/misc.c	22 Jul 2004 19:48:59 -0000	1.1
+++ arch/ppc/boot/prep/misc.c	4 Aug 2004 01:26:07 -0000	1.2
@@ -18,6 +18,7 @@
 #include <asm/bootinfo.h>
 #include <asm/mmu.h>
 #include <asm/byteorder.h>
+#include "of1275.h"
 #include "nonstdio.h"
 #include "zlib.h"
 
@@ -54,7 +55,6 @@
 RESIDUAL hold_resid_buf;
 RESIDUAL *hold_residual = &hold_resid_buf;
 unsigned long initrd_size = 0;
-unsigned long orig_MSR;
 
 char *zimage_start;
 int zimage_size;
@@ -67,14 +67,9 @@
 #endif /* CONFIG_VGA_CONSOLE */
 
 extern int CRT_tstc(void);
-extern void of_init(void *handler);
-extern int of_finddevice(const char *device_specifier, int *phandle);
-extern int of_getprop(int phandle, const char *name, void *buf, int buflen,
-		int *size);
 extern int vga_init(unsigned char *ISA_mem);
 extern void gunzip(void *, int, unsigned char *, int *);
 
-extern void _put_MSR(unsigned int val);
 extern unsigned long serial_init(int chan, void *ignored);
 extern void serial_fixups(void);
 
@@ -119,6 +114,27 @@
 }
 #endif /* CONFIG_VGA_CONSOLE */
 
+static void
+get_of_args(void)
+{
+	int size;
+	phandle chosen;
+	char buf[256];
+
+	/* Get bootargs property of /chosen node */
+	if (!(chosen = finddevice("/chosen")))
+		return;
+
+	if (getprop(chosen, "bootargs", buf, sizeof(buf)) != 4)
+		return;
+
+	if (size > sizeof(cmd_buf))
+		size = sizeof(cmd_buf);
+
+	if (size > 1) /* includes null-terminator */
+		memcpy(cmd_buf, buf, size);
+}
+
 unsigned long
 decompress_kernel(unsigned long load_addr, int num_words, unsigned long cksum,
 		  RESIDUAL *residual, void *OFW_interface)
@@ -131,14 +147,13 @@
 	char *cp;
 	/* Default to 32MiB memory. */
 	unsigned long TotalMemory = 0x02000000;
-	int dev_handle;
-	int mem_info[2];
-	int res, size;
-	unsigned char board_type;
-	unsigned char base_mod;
 	int start_multi = 0;
 	unsigned int pci_viddid, pci_did, tulip_pci_base, tulip_base;
 
+	/* If we have Open Firmware, initialise it immediately */
+	if (OFW_interface)
+		ofinit(OFW_interface);
+
 	serial_fixups();
 	com_port = serial_init(0, NULL);
 #if defined(CONFIG_VGA_CONSOLE)
@@ -175,7 +190,8 @@
 		/* Is this Motorola PPCBug? */
 		if ((1 & residual->VitalProductData.FirmwareSupports) &&
 		    (1 == residual->VitalProductData.FirmwareSupplier)) {
-			board_type = inb(0x800) & 0xF0;
+			unsigned char base_mod;
+			unsigned char board_type = inb(0x800) & 0xF0;
 
 			/*
 			 * Reset the onboard 21x4x Ethernet
@@ -231,35 +247,23 @@
 		 * we don't try this on a PReP box without OF
 		 *     -- Cort
 		 */
-		while (OFW_interface && ((unsigned long)OFW_interface < 0x10000000) )
+		while (OFW_interface)
 		{
-			/* We need to restore the slightly inaccurate
-			 * MSR so that OpenFirmware will behave. -- Tom
-			 */
-			_put_MSR(orig_MSR);
-			of_init(OFW_interface);
+			phandle dev_handle;
+			int mem_info[2];
 
 			/* get handle to memory description */
-			res = of_finddevice("/memory@0",
-					    &dev_handle);
-			if (res)
+			if (!(dev_handle = finddevice("/memory@0")))
 				break;
 
 			/* get the info */
-			res = of_getprop(dev_handle,
-					 "reg",
-					 mem_info,
-					 sizeof(mem_info),
-					 &size);
-			if (res)
+			if (getprop(dev_handle, "reg", mem_info,
+						sizeof(mem_info)) !=8)
 				break;
 
 			TotalMemory = mem_info[1];
 			break;
 		}
-
-		/* Enforce a sane MSR for booting. */
-		_put_MSR(MSR_IP);
         }
 
 	/* assume the chunk below 8M is free */
@@ -300,6 +304,10 @@
 	if (keyb_present)
 		CRT_tstc();  /* Forces keyboard to be initialized */
 
+	/* If we have OF then try to get args from there */
+	if (OFW_interface)
+		get_of_args();
+
 	puts("\nLinux/PPC load: ");
 	cp = cmd_line;
 	memcpy (cmd_line, cmd_preset, sizeof(cmd_preset));
@@ -338,6 +346,18 @@
 	*cp = 0;
 	puts("\nUncompressing Linux...");
 
+	/*
+	 * If we have OF, then we have deferred setting the MSR.
+	 * We must set it now because we are about to overwrite
+	 * the exception table.  The new MSR value will disable
+	 * machine check exceptions and point the exception table
+	 * to the ROM.
+	 */
+	if (OFW_interface) {
+		mtmsr(MSR_IP | MSR_FP);
+		asm volatile("isync");
+	}
+
 	gunzip(0, 0x400000, zimage_start, &zimage_size);
 	puts("done.\n");
 
@@ -353,7 +373,7 @@
 		unsigned long initrd_loc;
 		unsigned long rec_loc = _ALIGN((unsigned long)(zimage_size) +
 				(1 << 20) - 1, (1 << 20));
-		
+
 		rec = (struct bi_record *)rec_loc;
 
 		/* We need to make sure that the initrd and bi_recs do not
Index: arch/ppc/boot/prep/vreset.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/ppc/boot/prep/vreset.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/ppc/boot/prep/vreset.c	22 Jul 2004 19:48:59 -0000	1.1
+++ arch/ppc/boot/prep/vreset.c	4 Aug 2004 01:26:07 -0000	1.2
@@ -389,7 +389,7 @@
 extern void puts(const char *);
 static void unlockS3(void);
 
-static void inline
+static inline void
 outw(int port, unsigned short val)
 {
 	outb(port, val >> 8);
@@ -691,14 +691,14 @@
   unsigned long regs[NPCIREGS];
 } PCI_slots [NSLOTS] = {
 
-    { (unsigned long *)0x80808000, 0xDEADBEEF },   /* onboard */
-    { (unsigned long *)0x80800800, 0xDEADBEEF },   /* onboard */
-    { (unsigned long *)0x80801000, 0xDEADBEEF },   /* onboard */
-    { (unsigned long *)0x80802000, 0xDEADBEEF },   /* onboard */
-    { (unsigned long *)0x80804000, 0xDEADBEEF },   /* onboard */
-    { (unsigned long *)0x80810000, 0xDEADBEEF },   /* slot A/1 */
-    { (unsigned long *)0x80820000, 0xDEADBEEF },   /* slot B/2 */
-    { (unsigned long *)0x80840000, 0xDEADBEEF }    /* slot C/3 */
+    { (unsigned long *)0x80808000, {0xDEADBEEF,} },   /* onboard */
+    { (unsigned long *)0x80800800, {0xDEADBEEF,} },   /* onboard */
+    { (unsigned long *)0x80801000, {0xDEADBEEF,} },   /* onboard */
+    { (unsigned long *)0x80802000, {0xDEADBEEF,} },   /* onboard */
+    { (unsigned long *)0x80804000, {0xDEADBEEF,} },   /* onboard */
+    { (unsigned long *)0x80810000, {0xDEADBEEF,} },   /* slot A/1 */
+    { (unsigned long *)0x80820000, {0xDEADBEEF,} },   /* slot B/2 */
+    { (unsigned long *)0x80840000, {0xDEADBEEF,} }    /* slot C/3 */
 };
 
 
Index: arch/ppc/boot/simple/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/ppc/boot/simple/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/ppc/boot/simple/Makefile	22 Jul 2004 19:49:00 -0000	1.1
+++ arch/ppc/boot/simple/Makefile	4 Aug 2004 01:26:07 -0000	1.2
@@ -9,12 +9,10 @@
 # or implied.
 #
 # Notes:
-# (1) For machine targets which produce more than one image, define
-# ZNETBOOT and ZNETBOOTRD to the image which should be available for
-# 'znetboot' and 'znetboot.initrd`
-# (2) For machine targets which use the mktree program, define END to be
-# the machine name you want in the image, and you can optionally set
-# ENTRYPOINT which the image should be loaded at.  The optimal setting
+# (1) All machines must set the END variable to the suffix of the preferred
+# final image (i.e. would be copied in 'make znetboot'.
+# (2) For machine targets which use the mktree program you can optionally
+# set ENTRYPOINT which the image should be loaded at.  The optimal setting
 # for ENTRYPOINT is the link address.
 
 USE_STANDARD_AS_RULE		:= true
@@ -25,27 +23,58 @@
 ifeq ($(CONFIG_EMBEDDEDBOOT),y)
 ZIMAGE				:= zImage-EMBEDDED
 ZIMAGEINITRD			:= zImage.initrd-EMBEDDED
+MISC				:= misc-embedded.o
+END				:= embedded
+endif
+ifeq ($(CONFIG_IBM_OPENBIOS),y)
+ZIMAGE				:= zImage-TREE
+ZIMAGEINITRD			:= zImage.initrd-TREE
+END				:= treeboot
 TFTPIMAGE			:= /tftpboot/zImage.embedded
 MISC				:= misc-embedded.o
 endif
+ifeq ($(CONFIG_EBONY),y)
+ZIMAGE				:= zImage-TREE
+ZIMAGEINITRD			:= zImage.initrd-TREE
+END				:= ebony
+ENTRYPOINT			:= 0x00800000
+EXTRA				:= misc-44x.o
+endif
+ifeq ($(CONFIG_OCOTEA),y)
+ZIMAGE				:= zImage-TREE
+ZIMAGEINITRD			:= zImage.initrd-TREE
+END				:= ocotea
+ENTRYPOINT			:= 0x00800000
+EXTRA				:= misc-44x.o
+endif
 ifeq ($(CONFIG_GEMINI),y)
 ZIMAGE				:= zImage-SMON
 ZIMAGEINITRD			:= zImage.initrd-SMON
-TFTPIMAGE			:= /tftpboot/zImage.gemini
+END				:= gemini
 endif
-ifeq ($(CONFIG_LOPEC),y)
+# kbuild-2.4 'feature', only one of these will ever by 'y' at a time.
+# The rest will be unset.
+ifeq ($(CONFIG_LOPEC)$(CONFIG_PPLUS)$(CONFIG_PRPMC750),y)
 ZIMAGE				:= zImage-PPLUS
 ZIMAGEINITRD			:= zImage.initrd-PPLUS
 EXTRA				:= ../common/mpc10x_memory.o
 TFTPIMAGE			:= /tftpboot/zImage.pplus
-ZNETBOOT			:= zImage.pplus
-ZNETBOOTRD			:= zImage.initrd.pplus
+END				:= pplus
+endif
+ifeq ($(CONFIG_PPLUS),y)
+EXTRA				:= legacy.o
 endif
-
 ifeq ($(CONFIG_PAL4),y)
 ZIMAGE				:= zImage-PAL4
 ZIMAGEINITRD			:= zImage.initrd-PAL4
-TFTPIMAGE			:= /tftpboot/zImage.pal4
+END				:= pal4
+endif
+ifeq ($(CONFIG_SANDPOINT),y)
+ZIMAGE				:= zImage-SP
+ZIMAGEINITRD			:= zImage.initrd-SP
+CACHEFLAG			:= -include clear.S
+TFTPIMAGE			:= /tftpboot/zImage.sandpoint
+END				:= sandpoint
 endif
 ifeq ($(CONFIG_SPRUCE),y)
 ZIMAGE				:= zImage-TREE
@@ -53,18 +82,20 @@
 ENTRYPOINT			:= 0x00800000
 MISC				:= misc-spruce.o
 END				:= spruce
-TFTPIMAGE			:= /tftpboot/zImage.$(END)
 endif
+
+TFTPIMAGE			?= /tftpboot/zImage.$(END)
 ifeq ($(CONFIG_SMP),y)
 TFTPIMAGE			+= .smp
 endif
 
+
 # Setup a default address to put ourselves, change it as needed.
 LD_ARGS				= -T ../ld.script -Ttext 0x00800000 -Bstatic
 ifdef CONFIG_8xx
 LD_ARGS				:= -T ../ld.script -Ttext 0x00180000 -Bstatic
 endif
-ifeq ($(CONFIG_8260)$(CONFIG_4xx),y)
+ifeq ($(CONFIG_8260)$(CONFIG_40x),y)
 LD_ARGS				:= -T ../ld.script -Ttext 0x00400000 -Bstatic
 endif
 OBJCOPY_ARGS			:= -O elf32-powerpc
@@ -74,7 +105,7 @@
 				$(MISC) ../common/misc-common.o \
 				../common/string.o ../common/util.o \
 				../common/serial_stub.o
-obj-$(CONFIG_4xx)		+= embed_config.o
+obj-$(CONFIG_40x)		+= embed_config.o
 obj-$(CONFIG_8xx)		+= embed_config.o
 obj-$(CONFIG_8260)		+= embed_config.o
 obj-$(CONFIG_BSEIP)		+= iic.o
@@ -123,30 +154,22 @@
 	rm -f zvmlinux.initrd
 
 znetboot: zImage
-ifneq ($(ZNETBOOT),)
-	cp ../images/$(ZNETBOOT) $(TFTPIMAGE)
-else
-	cp ../images/zImage.* $(TFTPIMAGE)
-endif
+	cp ../images/zImage.$(END) $(TFTPIMAGE)
 
 znetboot.initrd: zImage.initrd
-ifneq ($(ZNETBOOTRD),)
-	cp ../images/$(ZNETBOOTRD) $(TFTPIMAGE)
-else
-	cp ../images/zImage.* $(TFTPIMAGE)
-endif
+	cp ../images/zImage.initrd.$(END) $(TFTPIMAGE)
 
 zImage-EMBEDDED: zvmlinux
-	mv zvmlinux ../images/zImage.embedded
+	mv zvmlinux ../images/zImage.$(END)
 
 zImage.initrd-EMBEDDED: zvmlinux.initrd
-	mv zvmlinux.initrd ../images/zImage.initrd.embedded
+	mv zvmlinux.initrd ../images/zImage.initrd.$(END)
 
 zImage-PAL4: zvmlinux
-	cp zvmlinux ../images/zImage.pal4
+	mv zvmlinux ../images/zImage.$(END)
 
 zImage.initrd-PAL4: zvmlinux.initrd
-	cp zvmlinux.initrd ../images/zImage.initrd.pal4
+	mv zvmlinux.initrd ../images/zImage.initrd.$(END)
 
 zImage-PPLUS: zvmlinux $(MKPREP) $(MKBUGBOOT)
 	$(MKPREP) -pbp zvmlinux ../images/zImage.pplus
@@ -156,11 +179,17 @@
 	$(MKPREP) -pbp zvmlinux.initrd ../images/zImage.initrd.pplus
 	$(MKBUGBOOT) zvmlinux.initrd ../images/zImage.initrd.bugboot
 
+zImage-SP: zvmlinux
+	mv zvmlinux ../images/zImage.sandpoint
+
+zImage.initrd-SP: zvmlinux.initrd
+	mv zvmlinux.initrd ../images/zImage.initrd.sandpoint
+
 zImage-SMON: zvmlinux
-	dd if=zvmlinux of=../images/zImage.gemini skip=64 bs=1k
+	dd if=zvmlinux of=../images/zImage.$(END) skip=64 bs=1k
 
 zImage.initrd-SMON: zvmlinux.initrd
-	dd if=zvmlinux.initrd of=../images/zImage.initrd.gemini skip=64 bs=1k
+	dd if=zvmlinux.initrd of=../images/zImage.initrd.$(END) skip=64 bs=1k
 
 zImage-TREE: zvmlinux
 	$(MKTREE) zvmlinux ../images/zImage.$(END) $(ENTRYPOINT)
Index: arch/ppc/boot/simple/embed_config.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/ppc/boot/simple/embed_config.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/ppc/boot/simple/embed_config.c	22 Jul 2004 19:49:00 -0000	1.1
+++ arch/ppc/boot/simple/embed_config.c	4 Aug 2004 01:26:07 -0000	1.2
@@ -14,7 +14,7 @@
 #endif
 #ifdef CONFIG_8260
 #include <asm/mpc8260.h>
-#include <asm/immap_8260.h>
+#include <asm/immap_cpm2.h>
 #endif
 #ifdef CONFIG_4xx
 #include <asm/io.h>
@@ -22,6 +22,7 @@
 #if defined(CONFIG_405GP) || defined(CONFIG_NP405H) || defined(CONFIG_NP405L)
 #include <linux/netdevice.h>
 #endif
+extern unsigned long timebase_period_ns;
 
 /* For those boards that don't provide one.
 */
@@ -51,7 +52,7 @@
 {
 	u_char	*mp;
 	u_char	eebuf[128];
-	int i;
+	int i = 8;
 	bd_t    *bd;
 
 	bd = *bdp;
@@ -63,11 +64,21 @@
 
 	/* All we are looking for is the Ethernet MAC address.  The
 	 * first 8 bytes are 'MOTOROLA', so check for part of that.
+	 * Next, the VPD describes a MAC 'packet' as being of type 08
+	 * and size 06.  So we look for that and the MAC must follow.
+	 * If there are more than one, we still only care about the first.
 	 * If it's there, assume we have a valid MAC address.  If not,
 	 * grab our default one.
 	 */
-	if ((*(uint *)eebuf) == 0x4d4f544f)
-		mp = &eebuf[0x4c];
+	if ((*(uint *)eebuf) == 0x4d4f544f) {
+		while (i < 127 && !(eebuf[i] == 0x08 && eebuf[i + 1] == 0x06))
+			 i += eebuf[i + 1] + 2;  /* skip this packet */
+
+		if (i == 127)	/* Couldn't find. */
+			mp = (u_char *)def_enet_addr;
+		else
+			mp = &eebuf[i + 2];
+	}
 	else
 		mp = (u_char *)def_enet_addr;
 
@@ -369,8 +380,8 @@
 
 	bd->bi_memstart = 0;
 	bd->bi_memsize = (8 * 1024 * 1024);
-	bd->bi_intfreq = 40000000;
-	bd->bi_busfreq = 40000000;
+	bd->bi_intfreq = 48000000;
+	bd->bi_busfreq = 48000000;
 }
 #endif /* FADS */
 
@@ -383,10 +394,10 @@
 clk_8260(bd_t *bd)
 {
 	uint	scmr, vco_out, clkin;
-	uint	plldf, pllmf, busdf, brgdf, cpmdf;
-	volatile immap_t	*ip;
+	uint	plldf, pllmf, busdf, cpmdf;
+	volatile cpm2_map_t	*ip;
 
-	ip = (immap_t *)IMAP_ADDR;
+	ip = (cpm2_map_t *)CPM_MAP_ADDR;
 	scmr = ip->im_clkrst.car_scmr;
 
 	/* The clkin is always bus frequency.
@@ -491,7 +502,6 @@
 embed_config(bd_t **bdp)
 {
 	u_char	*cp, *keyvals;
-	int	i;
 	bd_t	*bd;
 
 	keyvals = (u_char *)*bdp;
@@ -571,7 +581,7 @@
 	*/
 	bd->bi_intfreq = 200000000;
 }
-#endif /* RPX6 for testing */
+#endif /* RPX6 */
 
 #ifdef CONFIG_ADS8260
 void
@@ -640,7 +650,7 @@
 }
 #endif /* WILLOW */
 
-#ifdef CONFIG_TREEBOOT
+#ifdef CONFIG_IBM_OPENBIOS
 /* This could possibly work for all treeboot roms.
 */
 #define	BOARD_INFO_VECTOR	0xFFFE0B50
@@ -654,15 +664,12 @@
 	bd_t *(*get_board_info)(void) =
 	    (bd_t *(*)(void))(*(unsigned long *)BOARD_INFO_VECTOR);
 #if !defined(CONFIG_STB03xxx)
-	volatile emac_t *emacp;
-	emacp = (emac_t *)EMAC0_BASE;  /* assume 1st emac - armin */
-
 	/* shut down the Ethernet controller that the boot rom
 	 * sometimes leaves running.
 	 */
-	mtdcr(DCRN_MALCR, MALCR_MMSR);                /* 1st reset MAL */
-	while (mfdcr(DCRN_MALCR) & MALCR_MMSR) {};    /* wait for the reset */
-	emacp->em0mr0 = 0x20000000;        /* then reset EMAC */
+	mtdcr(DCRN_MALCR(DCRN_MAL_BASE), MALCR_MMSR);                /* 1st reset MAL */
+	while (mfdcr(DCRN_MALCR(DCRN_MAL_BASE)) & MALCR_MMSR) {};    /* wait for the reset */
+	out_be32((u32 *)EMAC0_BASE, 0x20000000);        /* then reset EMAC */
 	eieio();
 #endif
 
@@ -752,6 +759,6 @@
 	bd->bi_busfreq   = 100000000;
 	bd->bi_pci_busfreq= 33000000 ;
 #endif
+	timebase_period_ns = 1000000000 / bd->bi_tbfreq;
 }
 #endif
-
Index: arch/ppc/boot/simple/head.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/ppc/boot/simple/head.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/ppc/boot/simple/head.S	22 Jul 2004 19:49:00 -0000	1.1
+++ arch/ppc/boot/simple/head.S	4 Aug 2004 01:26:07 -0000	1.2
@@ -35,8 +35,8 @@
 	.globl	start
 start:
 	bl	start_
-#ifdef CONFIG_TREEBOOT
-	/* The IBM "Tree" bootrom knows that the address of the bootrom
+#ifdef CONFIG_IBM_OPENBIOS
+	/* The IBM OpenBIOS bootroms know that the address of the bootrom
 	 * read only structure is 4 bytes after _start.
 	 */
 	.long	0x62726f6d		# structure ID - "brom"
Index: arch/ppc/boot/simple/m8260_tty.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/ppc/boot/simple/m8260_tty.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/ppc/boot/simple/m8260_tty.c	22 Jul 2004 19:49:00 -0000	1.1
+++ arch/ppc/boot/simple/m8260_tty.c	4 Aug 2004 01:26:07 -0000	1.2
@@ -3,7 +3,8 @@
  */
 #include <linux/types.h>
 #include <asm/mpc8260.h>
-#include <asm/cpm_8260.h>
+#include <asm/immap_cpm2.h>
+#include <asm/cpm2.h>
 
 uint	no_print;
 extern char	*params[];
@@ -29,12 +30,12 @@
 	volatile scc_uart_t	*sup;
 #endif
 	volatile cbd_t	*tbdf, *rbdf;
-	volatile immap_t	*ip;
-	volatile iop8260_t	*io;
-	volatile cpm8260_t	*cp;
+	volatile cpm2_map_t	*ip;
+	volatile iop_cpm2_t	*io;
+	volatile cpm_cpm2_t	*cp;
 	uint	dpaddr, memaddr;
 
-	ip = (immap_t *)IMAP_ADDR;
+	ip = (cpm2_map_t *)CPM_MAP_ADDR;
 	cp = &ip->im_cpm;
 	io = &ip->im_ioport;
 
@@ -223,10 +224,10 @@
 	volatile char		*buf;
 	volatile smc_uart_t	*up;
 	volatile scc_uart_t	*sup;
-	volatile immap_t	*ip;
+	volatile cpm2_map_t	*ip;
 	int	i, nc;
 
-	ip = (immap_t *)IMAP_ADDR;
+	ip = (cpm2_map_t *)CPM_MAP_ADDR;
 
 #ifdef SCC_CONSOLE
 	sup = (scc_uart_t *)&ip->im_dprambase[PROFF_SCC1 + ((SCC_CONSOLE-1) << 8)];
@@ -255,10 +256,10 @@
 	volatile char		*buf;
 	volatile smc_uart_t	*up;
 	volatile scc_uart_t	*sup;
-	volatile immap_t	*ip;
+	volatile cpm2_map_t	*ip;
 	extern bd_t		*board_info;
 
-	ip = (immap_t *)IMAP_ADDR;
+	ip = (cpm2_map_t *)CPM_MAP_ADDR;
 #ifdef SCC_CONSOLE
 	sup = (scc_uart_t *)&ip->im_dprambase[PROFF_SCC1 + ((SCC_CONSOLE-1) << 8)];
 	tbdf = (cbd_t *)&ip->im_dprambase[sup->scc_genscc.scc_tbase];
@@ -298,9 +299,9 @@
 	volatile cbd_t		*rbdf;
 	volatile smc_uart_t	*up;
 	volatile scc_uart_t	*sup;
-	volatile immap_t	*ip;
+	volatile cpm2_map_t	*ip;
 
-	ip = (immap_t *)IMAP_ADDR;
+	ip = (cpm2_map_t *)CPM_MAP_ADDR;
 #ifdef SCC_CONSOLE
 	sup = (scc_uart_t *)&ip->im_dprambase[PROFF_SCC1 + ((SCC_CONSOLE-1) << 8)];
 	rbdf = (cbd_t *)&ip->im_dprambase[sup->scc_genscc.scc_rbase];
Index: arch/ppc/boot/simple/misc-embedded.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/ppc/boot/simple/misc-embedded.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/ppc/boot/simple/misc-embedded.c	22 Jul 2004 19:49:00 -0000	1.1
+++ arch/ppc/boot/simple/misc-embedded.c	4 Aug 2004 01:26:07 -0000	1.2
@@ -16,6 +16,7 @@
 #include <linux/types.h>
 #include <linux/elf.h>
 #include <asm/bootinfo.h>
+#include <asm/ibm4xx.h>
 #include <asm/mmu.h>
 #include <asm/mpc8xx.h>
 #include <asm/mpc8260.h>
@@ -78,6 +79,14 @@
 extern void gunzip(void *, int, unsigned char *, int *);
 extern void embed_config(bd_t **bp);
 
+/* Weak function for boards which don't need to build the
+ * board info struct because they are using PPCBoot/U-Boot.
+ */
+void __attribute__ ((weak))
+embed_config(bd_t **bdp)
+{
+}
+
 unsigned long
 load_kernel(unsigned long load_addr, int num_words, unsigned long cksum,
 		bd_t *bp)
Index: arch/ppc/boot/utils/mkbugboot.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/ppc/boot/utils/mkbugboot.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/ppc/boot/utils/mkbugboot.c	22 Jul 2004 19:48:59 -0000	1.1
+++ arch/ppc/boot/utils/mkbugboot.c	4 Aug 2004 01:26:07 -0000	1.2
@@ -1,8 +1,8 @@
 /*
  * arch/ppc/pp3boot/mkbugboot.c
- * 
- * Makes a Motorola PPCBUG ROM bootable image which can be flashed 
- * into one of the FLASH banks on a Motorola PowerPlus board. 
+ *
+ * Makes a Motorola PPCBUG ROM bootable image which can be flashed
+ * into one of the FLASH banks on a Motorola PowerPlus board.
  *
  * Author: Matt Porter <mporter@mvista.com>
  *
@@ -51,29 +51,22 @@
 /* size of read buffer */
 #define SIZE 0x1000
 
-#ifndef __sun__
-/* typedef long int32_t; */
-typedef unsigned long uint32_t;
-typedef unsigned short uint16_t;
-typedef unsigned char uint8_t;
-#endif
-
 /* PPCBUG ROM boot header */
 typedef struct bug_boot_header {
-  uint8_t	magic_word[4];		/* "BOOT" */
-  uint32_t	entry_offset;		/* Offset from top of header to code */
-  uint32_t	routine_length;		/* Length of code */
-  uint8_t	routine_name[8];	/* Name of the boot code */
+  unsigned char	magic_word[4];		/* "BOOT" */
+  unsigned long	entry_offset;		/* Offset from top of header to code */
+  unsigned long	routine_length;		/* Length of code */
+  unsigned char	routine_name[8];	/* Name of the boot code */
 } bug_boot_header_t;
 
 #define HEADER_SIZE	sizeof(bug_boot_header_t)
 
-uint32_t copy_image(int32_t in_fd, int32_t out_fd)
+unsigned long copy_image(int32_t in_fd, int32_t out_fd)
 {
-  uint8_t buf[SIZE];
+  unsigned char buf[SIZE];
   int n;
-  uint32_t image_size = 0;
-  uint8_t zero = 0;
+  unsigned long image_size = 0;
+  unsigned char zero = 0;
 
   lseek(in_fd, ELF_HEADER_SIZE, SEEK_SET);
 
@@ -95,11 +88,11 @@
   return image_size;
 }
 
-void write_bugboot_header(int32_t out_fd, uint32_t boot_size)
+void write_bugboot_header(int32_t out_fd, unsigned long boot_size)
 {
-  uint8_t header_block[HEADER_SIZE];
+  unsigned char header_block[HEADER_SIZE];
   bug_boot_header_t *bbh = (bug_boot_header_t *)&header_block[0];
-  
+
   memset(header_block, 0, HEADER_SIZE);
 
   /* Fill in the PPCBUG ROM boot header */
@@ -112,16 +105,16 @@
   write(out_fd, header_block, HEADER_SIZE);
 }
 
-uint16_t calc_checksum(int32_t bug_fd)
+unsigned short calc_checksum(int32_t bug_fd)
 {
-  uint32_t checksum_var = 0;
-  uint8_t buf[2];
+  unsigned long checksum_var = 0;
+  unsigned char buf[2];
   int n;
 
   /* Checksum loop */
   while ( (n = read(bug_fd, buf, 2) ) )
   {
-    checksum_var = checksum_var + *(uint16_t *)buf;
+    checksum_var = checksum_var + *(unsigned short *)buf;
 
     /* If we carry out, mask it and add one to the checksum */
     if (checksum_var >> 16)
@@ -135,9 +128,9 @@
 {
   int32_t image_fd, bugboot_fd;
   int argptr = 1;
-  uint32_t kernel_size = 0;
-  uint16_t checksum = 0;
-  uint8_t bugbootname[256];
+  unsigned long kernel_size = 0;
+  unsigned short checksum = 0;
+  unsigned char bugbootname[256];
 
   if ( (argc != 3) )
   {
@@ -146,7 +139,7 @@
   }
 
   /* Get file args */
-  
+
   /* kernel image file */
     if ((image_fd = open( argv[argptr] , 0)) < 0)
       exit(-1);
@@ -182,7 +175,7 @@
   bugboot_fd = open(bugbootname, O_RDWR);
 
   /* Calculate checksum */
-  checksum = calc_checksum(bugboot_fd);  
+  checksum = calc_checksum(bugboot_fd);
 
   /* Write out the calculated checksum */
   write(bugboot_fd, &checksum, 2);
Index: arch/ppc/boot/utils/mkprep.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/ppc/boot/utils/mkprep.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/ppc/boot/utils/mkprep.c	22 Jul 2004 19:48:59 -0000	1.1
+++ arch/ppc/boot/utils/mkprep.c	4 Aug 2004 01:26:07 -0000	1.2
@@ -12,12 +12,14 @@
  *                  -- Cort
  *
  * Modified for x86 hosted builds by Matt Porter <porter@neta.com>
+ * Modified for Sparc hosted builds by Peter Wahl <PeterWahl@web.de>
  */
 
 #include <fcntl.h>
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <strings.h>
 #include <sys/stat.h>
 #include <unistd.h>
 
@@ -96,14 +98,14 @@
   }
 
   /* needs to handle args more elegantly -- but this is a small/simple program */
-  
+
   /* check for -pbp */
   if ( !strcmp( argv[argptr], "-pbp" ) )
   {
     prep = 1;
     argptr++;
   }
-  
+
   /* check for -asm */
   if ( !strcmp( argv[argptr], "-asm" ) )
   {
@@ -130,7 +132,7 @@
   /* skip elf header in input file */
   /*if ( !prep )*/
   lseek(in_fd, elfhdr_size, SEEK_SET);
-  
+
   /* write prep partition if necessary */
   if ( prep )
 	  write_prep_partition( in_fd, out_fd );
@@ -140,26 +142,26 @@
 	  write_asm_data( in_fd, out_fd );
   else
 	  copy_image(in_fd, out_fd);
-  
+
   return 0;
 }
 
 void write_prep_partition(int in, int out)
 {
   unsigned char block[512];
-  partition_entry_t *pe = (partition_entry_t *)&block[0x1BE];
+  partition_entry_t pe;
   dword_t *entry  = (dword_t *)&block[0];
   dword_t *length = (dword_t *)&block[sizeof(long)];
   struct stat info;
-  
+
   if (fstat(in, &info) < 0)
   {
     fprintf(stderr,"info failed\n");
     exit(-1);
   }
-  
+
   bzero( block, sizeof block );
- 
+
   /* set entry point and boot image size skipping over elf header */
 #ifdef __i386__
   *entry = 0x400/*+65536*/;
@@ -172,13 +174,13 @@
   /* sets magic number for msdos partition (used by linux) */
   block[510] = 0x55;
   block[511] = 0xAA;
-  
+
   /*
    * Build a "PReP" partition table entry in the boot record
    *  - "PReP" may only look at the system_indicator
    */
-  pe->boot_indicator   = BootActive;
-  pe->system_indicator = SystemPrep;
+  pe.boot_indicator   = BootActive;
+  pe.system_indicator = SystemPrep;
   /*
    * The first block of the diskette is used by this "boot record" which
    * actually contains the partition table. (The first block of the
@@ -186,12 +188,12 @@
    * one partition on the diskette and it shall contain the rest of the
    * diskette.
    */
-  pe->starting_head     = 0;	/* zero-based			     */
-  pe->starting_sector   = 2;	/* one-based			     */
-  pe->starting_cylinder = 0;	/* zero-based			     */
-  pe->ending_head       = 1;	/* assumes two heads		     */
-  pe->ending_sector     = 18;	/* assumes 18 sectors/track	     */
-  pe->ending_cylinder   = 79;	/* assumes 80 cylinders/diskette     */
+  pe.starting_head     = 0;	/* zero-based			     */
+  pe.starting_sector   = 2;	/* one-based			     */
+  pe.starting_cylinder = 0;	/* zero-based			     */
+  pe.ending_head       = 1;	/* assumes two heads		     */
+  pe.ending_sector     = 18;	/* assumes 18 sectors/track	     */
+  pe.ending_cylinder   = 79;	/* assumes 80 cylinders/diskette     */
 
   /*
    * The "PReP" software ignores the above fields and just looks at
@@ -201,25 +203,27 @@
    *   - unlike the above sector numbers, the beginning sector is zero-based!
    */
 #if 0
-  pe->beginning_sector  = cpu_to_le32(1);
+  pe.beginning_sector  = cpu_to_le32(1);
 #else
-  /* This has to be 0 on the PowerStack? */   
+  /* This has to be 0 on the PowerStack? */
 #ifdef __i386__
-  pe->beginning_sector  = 0;
+  pe.beginning_sector  = 0;
 #else
-  pe->beginning_sector  = cpu_to_le32(0);
+  pe.beginning_sector  = cpu_to_le32(0);
 #endif /* __i386__ */
-#endif    
+#endif
 
 #ifdef __i386__
-  pe->number_of_sectors = 2*18*80-1;
+  pe.number_of_sectors = 2*18*80-1;
 #else
-  pe->number_of_sectors = cpu_to_le32(2*18*80-1);
+  pe.number_of_sectors = cpu_to_le32(2*18*80-1);
 #endif /* __i386__ */
 
+  memcpy(&block[0x1BE],&pe,sizeof(pe));
+
   write( out, block, sizeof(block) );
   write( out, entry, sizeof(*entry) );
-  write( out, length, sizeof(*length) );  
+  write( out, length, sizeof(*length) );
   /* set file position to 2nd sector where image will be written */
   lseek( out, 0x400, SEEK_SET );
 }
@@ -245,7 +249,7 @@
   unsigned char *lp;
   unsigned char buf[SIZE];
   unsigned char str[256];
-  
+
   write( out, "\t.data\n\t.globl input_data\ninput_data:\n",
 	 strlen( "\t.data\n\t.globl input_data\ninput_data:\n" ) );
   pos = 0;
Index: arch/ppc/kernel/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/ppc/kernel/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/ppc/kernel/Makefile	22 Jul 2004 19:49:02 -0000	1.1
+++ arch/ppc/kernel/Makefile	4 Aug 2004 01:26:08 -0000	1.2
@@ -23,22 +23,28 @@
 # Start off with 'head.o', change as needed.
 HEAD-y				:= head.o
 HEAD-$(CONFIG_6xx)		+= idle_6xx.o
-HEAD-$(CONFIG_4xx)		:= head_4xx.o
+HEAD-$(CONFIG_40x)		:= head_4xx.o
+HEAD-$(CONFIG_44x)		:= head_44x.o
 HEAD-$(CONFIG_8xx)		:= head_8xx.o
 
 all: $(HEAD-y) kernel.o
 
 O_TARGET := kernel.o
 
-export-objs			:= ppc_ksyms.o time.o
+export-objs			:= ppc_ksyms.o time.o ocp.o ppc4xx_setup.o \
+					ppc4xx_dma.o ppc4xx_sgdma.o \
+					ppc4xx_stbdma.o
 
 obj-y				:= entry.o traps.o irq.o idle.o time.o misc.o \
 					process.o signal.o ptrace.o align.o \
 					semaphore.o syscalls.o setup.o \
 					cputable.o ppc_htab.o
+ifneq ($(CONFIG_6xx),y)
+obj-y				+= idle_gen.o
+endif
 obj-$(CONFIG_6xx)		+= l2cr.o cpu_setup_6xx.o
 obj-$(CONFIG_MODULES)		+= ppc_ksyms.o
-obj-$(CONFIG_PCI)		+= pci.o 
+obj-$(CONFIG_PCI)		+= pci.o
 obj-$(CONFIG_PCI)		+= pci-dma.o
 obj-$(CONFIG_KGDB)		+= ppc-stub.o
 obj-$(CONFIG_PPCBUG_NVRAM)	+= prep_nvram.o
@@ -48,8 +54,21 @@
 obj-$(CONFIG_KGDB)		+= gen550_kgdb.o gen550_dbg.o
 obj-$(CONFIG_SERIAL_TEXT_DEBUG)	+= gen550_dbg.o
 endif
-obj-$(CONFIG_4xx)		+= ppc4xx_pic.o
+obj-$(CONFIG_PPC_OCP)		+= ocp.o
+obj-$(CONFIG_40x)		+= ppc4xx_setup.o ppc4xx_pic.o
+obj-$(CONFIG_4xx)		+= todc_time.o
+obj-$(CONFIG_STBXXX_DMA)	+= ppc4xx_stbdma.o
+ifeq ($(CONFIG_PCI),y)
+obj-$(CONFIG_40x)		+= ppc405_pci.o
+obj-$(CONFIG_4xx)		+= indirect_pci.o pci_auto.o
+endif
+obj-$(CONFIG_44x)		+= ppc4xx_pic.o ibm44x_common.o
+obj-$(CONFIG_440GP)		+= ibm440gp_common.o
+obj-$(CONFIG_440GX)		+= ibm440gx_common.o
+obj-$(CONFIG_PPC4xx_DMA)	+= ppc4xx_dma.o
+obj-$(CONFIG_PPC4xx_EDMA)	+= ppc4xx_sgdma.o
 obj-$(CONFIG_8xx)		+= m8xx_setup.o ppc8xx_pic.o
+obj-$(CONFIG_8xx_WDT)		+= m8xx_wdt.o
 ifeq ($(CONFIG_8xx),y)
 obj-$(CONFIG_PCI)		+= qspan_pci.o
 ifndef CONFIG_MATH_EMULATION
@@ -63,8 +82,14 @@
 obj-$(CONFIG_LOPEC)		+= mpc10x_common.o indirect_pci.o pci_auto.o \
 					open_pic.o i8259.o todc_time.o
 obj-$(CONFIG_PAL4)		+= indirect_pci.o pci_auto.o todc_time.o
+obj-$(CONFIG_PPLUS)		+= pplus_common.o open_pic.o i8259.o \
+				   indirect_pci.o todc_time.o pci_auto.o
+obj-$(CONFIG_PRPMC750)		+= open_pic.o indirect_pci.o pci_auto.o \
+					pplus_common.o
+obj-$(CONFIG_SANDPOINT)		+= i8259.o open_pic.o mpc10x_common.o \
+					pci_auto.o indirect_pci.o todc_time.o
 obj-$(CONFIG_SPRUCE)		+= indirect_pci.o pci_auto.o todc_time.o
-obj-$(CONFIG_8260)		+= m8260_setup.o ppc8260_pic.o
+obj-$(CONFIG_8260)		+= m8260_setup.o cpm2_pic.o
 obj-$(CONFIG_BOOTX_TEXT)	+= btext.o
 
 include $(TOPDIR)/Rules.make
@@ -74,6 +99,7 @@
 l2cr.o: l2cr.S ppc_defs.h
 head.o: head.S ppc_defs.h
 head_4xx.o: head_4xx.S ppc_defs.h
+head_44x.o: head_44x.S ppc_defs.h
 head_8xx.o: head_8xx.S ppc_defs.h
 idle_6xx.o: idle_6xx.S ppc_defs.h
 
